import{s as ft,o as pt}from"../chunks/scheduler.7bc62968.js";import{S as mt,i as dt,g as l,s as a,r as f,A as gt,h as o,f as i,c as s,j as ot,u as p,x as r,k as rt,y as yt,a as n,v as m,d,t as g,w as y,m as ct,n as ut}from"../chunks/index.66556066.js";import{T as ht}from"../chunks/Tip.ad57eee8.js";import{H as Q}from"../chunks/Heading.3f0870db.js";function vt(X){let h;return{c(){h=ct(`Be sure to double check that your dataset doesn't have the following types of
  patterns!`)},l(c){h=ut(c,`Be sure to double check that your dataset doesn't have the following types of
  patterns!`)},m(c,u){n(c,h,u)},d(c){c&&i(h)}}}function $t(X){let h;return{c(){h=ct("Try to make sure your dataset reflects the variety found in the real world!")},l(c){h=ut(c,"Try to make sure your dataset reflects the variety found in the real world!")},m(c,u){n(c,h,u)},d(c){c&&i(h)}}}function wt(X){let h,c,u,ee,w,te,x,De="Training machine learning models requires vast amounts of data. Synthetic data can help by addressing privacy issues, augmenting limited data, and correcting imbalances in the real data. We have learned how to generate synthetic data using several different methods. Before using synthetic data to train a model, however, there are several important things that need to be considered.",ie,b,ne,C,ze=`Overfitting occurs when a machine learning model learns the training data so well that it doesn’t perform well on new, unseen data.
It’s akin to learning a specific way to solve a problem but then encountering a new situation where the strategy doesn’t work. If the process of generating synthetic data is too simple or there are are overly-consistent patterns, your model might overfit to the limited variations present in the synthetic data. As a very simple example, suppose you trained a model using a synthetic dataset of 25 red circles and 25 blue squares. The model will probably learn to associate circles with the color red and squares with the color blue. This model would likely fail if presented with a red square.`,ae,v,se,T,je='<em>Overly Consistent Color</em> <img src="https://huggingface.co/datasets/hf-vision/course-assets/blob/main/synthetic-data-creation-overfit/overfit-color.jpg" alt="consistent-color"/>',le,_,Fe='<em>Overly Consistent Size</em> <img src="https://huggingface.co/datasets/hf-vision/course-assets/blob/main/synthetic-data-creation-overfit/overfit-size.jpg" alt="consistent-size"/>',oe,L,Ee='<em>Overly Consistent Background</em> <img src="https://huggingface.co/datasets/hf-vision/course-assets/blob/main/synthetic-data-creation-overfit/overfit-background.jpg" alt="consistent-background"/>',re,P,Oe='<em>Overly Consistent Location</em> <img src="https://huggingface.co/datasets/hf-vision/course-assets/blob/main/synthetic-data-creation-overfit/overfit-location.jpg" alt="consistent-location"/>',he,I,ce,M,Ge="If the process of generating synthetic data has biases or inaccuracies, your model may unintentionally learn and perpetuate those biases. Beware of the following pitfalls:",ue,H,Be="<strong>Limited Diversity</strong>",fe,k,Re="One challenge is that synthetic data may fail to adequately represent the complexity and diversity of the real data. The shape example might seem trivial, but there are lots of situations where failing to account for the wide variety of people, places, animals, or objects will result in a model that doesn’t perform well. For example, suppose you wanted to train a model to monitor the population of an endangered species, such as aye-aye lemurs. If your dataset only contains images of ring-tailed lemurs, the model might struggle to accurately identify aye-aye lemurs in the wild. This limitation could lead to errors in population assessments. The great thing is that if you are mindful of any imbalances in the underlying dataset, you can potentially use synthetic data to de-bias the real data by augmenting with synthetic data from the under-represented class.",pe,$,me,A,Ne='<strong>Nice Variety</strong> <img src="https://huggingface.co/datasets/hf-vision/course-assets/blob/main/synthetic-data-creation-overfit/good-variety.jpg" alt="nice-variety"/>',de,q,Ue="<strong>Copying Existing Biases:</strong>",ge,S,We="If the data you used to create the synthetic images already had biases, your model might unintentionally learn and replicate those biases. It’s like copying a friend’s notes without realizing they made a mistake – your computer might end up with the same errors.",ye,D,ve,z,Ve="Generating high-quality synthetic data can be computationally expensive. This may pose challenges in terms of both time and resources, especially for complex models or large datasets. As a general rule, generating and using a synthetic dataset only makes sense if it ultimately saves resources (money, time, etc.).",$e,j,we,F,Ke="Let’s consider the lung images we generated using DCGAN. While some of the images looked pretty realistic, others were not so good. A model trained with the low-quality images might fail to detect pneumonia because they contained noise that isn’t present in the real images. It is also possible that your model might get really good at recognizing patterns in the synthetic data, but those patterns might not existor may be different in the real world.",xe,E,Ye="A good practice is to evaluate your dataset using a metric such as Frechet Inception Distance (FID), Inception Score (IS), or the Classification Accuracy Score (CAS).",be,O,Je="<em>FID:</em>",Ce,G,Qe='FID uses a pre-trained neural network model, often <a href="https://huggingface.co/docs/timm/models/inception-v4" rel="nofollow">Inception</a>, which is good at recognizing objects in images. The model is used to extract features from both the real and generated images.FID is a measure of how “far” one distribution is from another, taking into account both the mean and covariance of the distributions.',Te,B,Xe=`A low FID suggests that the feature distributions of real and generated images are similar and the generated images are more likely
to be realistic.`,_e,R,Ze="<em>IS:</em>",Le,N,et=`IS uses a pre-trained Inception model to evaluate the quality of generated images produced by generative models, particularly GANs.
For each generated image, the Inception model assigns a score based on its confidence in recognizing objects within that image. High scores are better and indicate that the Inception model is confident about the content of the image.`,Pe,U,tt="<em>CAS:</em>",Ie,W,it="Classification accuracy is another measure of how well your model is performing on the synthetic data. A higher accuracy indicates that the model is effectively capturing the features and patterns of the real images. Low accuracy scores for certain classes may indicate issues with the generation process, such as unrealistic backgrounds, incorrect textures, or inconsistent lighting conditions. You can use CIS to help you identify and address these problems to improve the overall quality of the synthetic dataset.",Me,V,He,K,nt="Even after training your model, it is crucial to continuously monitor its performance in real-world scenarios. If your model encounters new situations or trends that weren’t present in the synthetic data, it might struggle to adapt. Addressing these challenges involves mindful design of the synthetic data generation process and evaluation of the model’s performance on real data. Applying these principles will help to unlock the potential of synthetic data!",ke,Y,Ae,J,at='<li><a href="https://arxiv.org/pdf/2303.01268.pdf" rel="nofollow">Analyzing Effects of Fake Training Data on the Performance of Deep Learning Systems</a></li> <li><a href="https://arxiv.org/pdf/2305.10118.pdf" rel="nofollow">Bridging the Gap: Enhancing the Utility of Synthetic Data Via Post-Processing Techniques</a></li> <li><a href="https://arxiv.org/pdf/2303.14126.pdf" rel="nofollow">CIFAKE: Image Classification and Explanable Identification of AI-Generated Synthetic Images</a></li> <li><a href="https://arxiv.org/abs/1905.10887" rel="nofollow">Classification Accuracy Score for Conditional Generative Models</a></li> <li><a href="https://arxiv.org/abs/1706.08500" rel="nofollow">GANs Trained by a Two Time-Scale Update Rule Converge to a Local Nash Equilibrium</a></li> <li><a href="https://arxiv.org/abs/1606.03498" rel="nofollow">Improved Techniques for Training GANs</a></li> <li><a href="https://arxiv.org/pdf/1512.00567v3.pdf" rel="nofollow">Rethinking the Inception Architecture for Computer Vision</a></li> <li><a href="https://github.com/huggingface/community-events/tree/main/huggan/pytorch/metrics" rel="nofollow">Metrics</a></li> <li><a href="https://github.com/mseitzer/pytorch-fid" rel="nofollow">pytorch-fid</a></li>',qe,Z,Se;return w=new Q({props:{title:"Challenges and Opportunities Associated With Using Synthetic Data",local:"challenges-and-opportunities-associated-with-using-synthetic-data",headingTag:"h1"}}),b=new Q({props:{title:"Overfitting the Model",local:"overfitting-the-model",headingTag:"h2"}}),v=new ht({props:{warning:"true",$$slots:{default:[vt]},$$scope:{ctx:X}}}),I=new Q({props:{title:"Are there biases in the synthetic data?",local:"are-there-biases-in-the-synthetic-data",headingTag:"h2"}}),$=new ht({props:{$$slots:{default:[$t]},$$scope:{ctx:X}}}),D=new Q({props:{title:"Does the benefit of using synthetic data outweigh the computational cost?",local:"does-the-benefit-of-using-synthetic-data-outweigh-the-computational-cost",headingTag:"h2"}}),j=new Q({props:{title:"What is the perceived quality of the synthetic images?",local:"what-is-the-perceived-quality-of-the-synthetic-images",headingTag:"h3"}}),V=new Q({props:{title:"Conclusion",local:"conclusion",headingTag:"h2"}}),Y=new Q({props:{title:"Resources and Further Reading",local:"resources-and-further-reading",headingTag:"h2"}}),{c(){h=l("meta"),c=a(),u=l("p"),ee=a(),f(w.$$.fragment),te=a(),x=l("p"),x.textContent=De,ie=a(),f(b.$$.fragment),ne=a(),C=l("p"),C.textContent=ze,ae=a(),f(v.$$.fragment),se=a(),T=l("p"),T.innerHTML=je,le=a(),_=l("p"),_.innerHTML=Fe,oe=a(),L=l("p"),L.innerHTML=Ee,re=a(),P=l("p"),P.innerHTML=Oe,he=a(),f(I.$$.fragment),ce=a(),M=l("p"),M.textContent=Ge,ue=a(),H=l("p"),H.innerHTML=Be,fe=a(),k=l("p"),k.textContent=Re,pe=a(),f($.$$.fragment),me=a(),A=l("p"),A.innerHTML=Ne,de=a(),q=l("p"),q.innerHTML=Ue,ge=a(),S=l("p"),S.textContent=We,ye=a(),f(D.$$.fragment),ve=a(),z=l("p"),z.textContent=Ve,$e=a(),f(j.$$.fragment),we=a(),F=l("p"),F.textContent=Ke,xe=a(),E=l("p"),E.textContent=Ye,be=a(),O=l("p"),O.innerHTML=Je,Ce=a(),G=l("p"),G.innerHTML=Qe,Te=a(),B=l("p"),B.textContent=Xe,_e=a(),R=l("p"),R.innerHTML=Ze,Le=a(),N=l("p"),N.textContent=et,Pe=a(),U=l("p"),U.innerHTML=tt,Ie=a(),W=l("p"),W.textContent=it,Me=a(),f(V.$$.fragment),He=a(),K=l("p"),K.textContent=nt,ke=a(),f(Y.$$.fragment),Ae=a(),J=l("ul"),J.innerHTML=at,qe=a(),Z=l("p"),this.h()},l(e){const t=gt("svelte-u9bgzb",document.head);h=o(t,"META",{name:!0,content:!0}),t.forEach(i),c=s(e),u=o(e,"P",{}),ot(u).forEach(i),ee=s(e),p(w.$$.fragment,e),te=s(e),x=o(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-u7qs1"&&(x.textContent=De),ie=s(e),p(b.$$.fragment,e),ne=s(e),C=o(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-11btgvk"&&(C.textContent=ze),ae=s(e),p(v.$$.fragment,e),se=s(e),T=o(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-1ju2l5q"&&(T.innerHTML=je),le=s(e),_=o(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-1qc5kns"&&(_.innerHTML=Fe),oe=s(e),L=o(e,"P",{"data-svelte-h":!0}),r(L)!=="svelte-182ia2v"&&(L.innerHTML=Ee),re=s(e),P=o(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-18pvdne"&&(P.innerHTML=Oe),he=s(e),p(I.$$.fragment,e),ce=s(e),M=o(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-1qrtcjb"&&(M.textContent=Ge),ue=s(e),H=o(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-9zsifk"&&(H.innerHTML=Be),fe=s(e),k=o(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-123qi28"&&(k.textContent=Re),pe=s(e),p($.$$.fragment,e),me=s(e),A=o(e,"P",{"data-svelte-h":!0}),r(A)!=="svelte-1esddtc"&&(A.innerHTML=Ne),de=s(e),q=o(e,"P",{"data-svelte-h":!0}),r(q)!=="svelte-8t5p2y"&&(q.innerHTML=Ue),ge=s(e),S=o(e,"P",{"data-svelte-h":!0}),r(S)!=="svelte-uxf8nr"&&(S.textContent=We),ye=s(e),p(D.$$.fragment,e),ve=s(e),z=o(e,"P",{"data-svelte-h":!0}),r(z)!=="svelte-10d2zlq"&&(z.textContent=Ve),$e=s(e),p(j.$$.fragment,e),we=s(e),F=o(e,"P",{"data-svelte-h":!0}),r(F)!=="svelte-2nhqea"&&(F.textContent=Ke),xe=s(e),E=o(e,"P",{"data-svelte-h":!0}),r(E)!=="svelte-153wbhu"&&(E.textContent=Ye),be=s(e),O=o(e,"P",{"data-svelte-h":!0}),r(O)!=="svelte-1xl2ts6"&&(O.innerHTML=Je),Ce=s(e),G=o(e,"P",{"data-svelte-h":!0}),r(G)!=="svelte-1sz1dvu"&&(G.innerHTML=Qe),Te=s(e),B=o(e,"P",{"data-svelte-h":!0}),r(B)!=="svelte-1p1oso0"&&(B.textContent=Xe),_e=s(e),R=o(e,"P",{"data-svelte-h":!0}),r(R)!=="svelte-1kcxc5n"&&(R.innerHTML=Ze),Le=s(e),N=o(e,"P",{"data-svelte-h":!0}),r(N)!=="svelte-8uvvpg"&&(N.textContent=et),Pe=s(e),U=o(e,"P",{"data-svelte-h":!0}),r(U)!=="svelte-1djui6c"&&(U.innerHTML=tt),Ie=s(e),W=o(e,"P",{"data-svelte-h":!0}),r(W)!=="svelte-19os934"&&(W.textContent=it),Me=s(e),p(V.$$.fragment,e),He=s(e),K=o(e,"P",{"data-svelte-h":!0}),r(K)!=="svelte-11to9w1"&&(K.textContent=nt),ke=s(e),p(Y.$$.fragment,e),Ae=s(e),J=o(e,"UL",{"data-svelte-h":!0}),r(J)!=="svelte-18lx4ro"&&(J.innerHTML=at),qe=s(e),Z=o(e,"P",{}),ot(Z).forEach(i),this.h()},h(){rt(h,"name","hf:doc:metadata"),rt(h,"content",xt)},m(e,t){yt(document.head,h),n(e,c,t),n(e,u,t),n(e,ee,t),m(w,e,t),n(e,te,t),n(e,x,t),n(e,ie,t),m(b,e,t),n(e,ne,t),n(e,C,t),n(e,ae,t),m(v,e,t),n(e,se,t),n(e,T,t),n(e,le,t),n(e,_,t),n(e,oe,t),n(e,L,t),n(e,re,t),n(e,P,t),n(e,he,t),m(I,e,t),n(e,ce,t),n(e,M,t),n(e,ue,t),n(e,H,t),n(e,fe,t),n(e,k,t),n(e,pe,t),m($,e,t),n(e,me,t),n(e,A,t),n(e,de,t),n(e,q,t),n(e,ge,t),n(e,S,t),n(e,ye,t),m(D,e,t),n(e,ve,t),n(e,z,t),n(e,$e,t),m(j,e,t),n(e,we,t),n(e,F,t),n(e,xe,t),n(e,E,t),n(e,be,t),n(e,O,t),n(e,Ce,t),n(e,G,t),n(e,Te,t),n(e,B,t),n(e,_e,t),n(e,R,t),n(e,Le,t),n(e,N,t),n(e,Pe,t),n(e,U,t),n(e,Ie,t),n(e,W,t),n(e,Me,t),m(V,e,t),n(e,He,t),n(e,K,t),n(e,ke,t),m(Y,e,t),n(e,Ae,t),n(e,J,t),n(e,qe,t),n(e,Z,t),Se=!0},p(e,[t]){const st={};t&2&&(st.$$scope={dirty:t,ctx:e}),v.$set(st);const lt={};t&2&&(lt.$$scope={dirty:t,ctx:e}),$.$set(lt)},i(e){Se||(d(w.$$.fragment,e),d(b.$$.fragment,e),d(v.$$.fragment,e),d(I.$$.fragment,e),d($.$$.fragment,e),d(D.$$.fragment,e),d(j.$$.fragment,e),d(V.$$.fragment,e),d(Y.$$.fragment,e),Se=!0)},o(e){g(w.$$.fragment,e),g(b.$$.fragment,e),g(v.$$.fragment,e),g(I.$$.fragment,e),g($.$$.fragment,e),g(D.$$.fragment,e),g(j.$$.fragment,e),g(V.$$.fragment,e),g(Y.$$.fragment,e),Se=!1},d(e){e&&(i(c),i(u),i(ee),i(te),i(x),i(ie),i(ne),i(C),i(ae),i(se),i(T),i(le),i(_),i(oe),i(L),i(re),i(P),i(he),i(ce),i(M),i(ue),i(H),i(fe),i(k),i(pe),i(me),i(A),i(de),i(q),i(ge),i(S),i(ye),i(ve),i(z),i($e),i(we),i(F),i(xe),i(E),i(be),i(O),i(Ce),i(G),i(Te),i(B),i(_e),i(R),i(Le),i(N),i(Pe),i(U),i(Ie),i(W),i(Me),i(He),i(K),i(ke),i(Ae),i(J),i(qe),i(Z)),i(h),y(w,e),y(b,e),y(v,e),y(I,e),y($,e),y(D,e),y(j,e),y(V,e),y(Y,e)}}}const xt='{"title":"Challenges and Opportunities Associated With Using Synthetic Data","local":"challenges-and-opportunities-associated-with-using-synthetic-data","sections":[{"title":"Overfitting the Model","local":"overfitting-the-model","sections":[],"depth":2},{"title":"Are there biases in the synthetic data?","local":"are-there-biases-in-the-synthetic-data","sections":[],"depth":2},{"title":"Does the benefit of using synthetic data outweigh the computational cost?","local":"does-the-benefit-of-using-synthetic-data-outweigh-the-computational-cost","sections":[{"title":"What is the perceived quality of the synthetic images?","local":"what-is-the-perceived-quality-of-the-synthetic-images","sections":[],"depth":3}],"depth":2},{"title":"Conclusion","local":"conclusion","sections":[],"depth":2},{"title":"Resources and Further Reading","local":"resources-and-further-reading","sections":[],"depth":2}],"depth":1}';function bt(X){return pt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Pt extends mt{constructor(h){super(),dt(this,h,bt,wt,ft,{})}}export{Pt as component};
