import{s as Oe,n as We,o as Be}from"../chunks/scheduler.7bc62968.js";import{S as Ge,i as Ve,g as o,s,r as P,A as Ye,h as r,f as i,c as a,j as ze,u as j,x as l,k as Ne,y as Je,a as n,v as A,d as q,t as E,w as z}from"../chunks/index.66556066.js";import{H as N}from"../chunks/Heading.3f0870db.js";function Ke(we){let c,B,O,G,u,V,p,Y,f,xe="Representing features in data is crucial for organizing and manipulating data effectively. Features, or attributes or variables, can be diverse, ranging from numerical values and categories to more complex structures like images or text. Some ways to represent features for computer vision tasks are:",J,m,Te="<li><p><strong>Numerical features</strong></p> <ul><li>Arrays/Lists: Simplest form to store numerical values. Each element in the array corresponds to a feature.</li> <li>Tensors: Multidimensional arrays often used in the machine learning frameworks to handle large sets of numerical data efficiently.</li></ul></li> <li><p><strong>Categorical features</strong></p> <ul><li>Dictionaries/Lists: Assigning categories to numerical labels or directly storing categorical values.</li> <li>One hot encoding: Transforming categorical variables into binary vectors where each bit represents a category.</li></ul></li> <li><p><strong>Image features</strong></p> <ul><li>Pixel Values: Strong pixel values matrices or multi-dimensional arrays.</li> <li>Convolutional Neural Network features(CNN): Extracting features using pre-trained CNN models.</li></ul></li>",K,g,Q,d,Ce="A good descriptor in image processing or computer vision is a set of characteristics or features that effectively represent key information about an object or scene in an image. Here are some aspects that contribute to making a good descriptor:",X,h,ke="<li><strong>Invariant to transformation:</strong> Descriptors should ideally be robust to variations like rotation, translation, scaling and changes in illumination. This means that regardless of how an object is positioned or how the image is altered, the descriptor should remain relatively unchanged and contain the same description as the original one.</li> <li><strong>Distinctiveness:</strong> A good descriptor captures unique information about the object. It should be able to discriminate between different objects or parts of an image and be distinct enough to differentiate them from similar elements.</li> <li><strong>Dimensionality:</strong> Good descriptors often have a manageable size, conveying enough information without being excessively large. Balancing dimensionality is crucial for efficiency in processing and storage.</li> <li><strong>Locality:</strong> Descriptors often identify local features within an image. Local descriptors focus on specific regions or keypoints and describe the characteristics of these areas, enabling matching and recognition of similar regions across different images.</li> <li><strong>Repeatability:</strong> Descriptors should be consistent and reproducible across multiple instances of the same object or scene even in the presence of noise or minor variations.</li> <li><strong>Compatibility with Matching Algorithms:</strong> Descriptors are often used in conjunction with matching algorithms to find correspondences between different images. A good descriptor should be suitable for the matching algorithm being used, whether it’s based on distance metrics, machine learning models, or other techniques.</li> <li><strong>Computational Efficiency:</strong> Efficiency is really a crucial part of a descriptor, especially in real-time applications. Descriptors should be computationally feasible for quick processing, particularly in scenarios where speed is crucial, such as robotics or autonomous vehicles.</li> <li><strong>Adaptability:</strong> Descriptors that can adapt or learn from the data they are processing can be highly effective, especially in situations where the characteristics of the objects or scenes may change over time. This can increase the useability of the descriptor.</li> <li><strong>Noise Robustness:</strong> Descriptors should be able to handle noise in the image data without significantly compromising their ability to represent the underlying features accurately.</li>",Z,v,ee,b,te,y,$e='<img src="https://huggingface.co/datasets/hf-vision/course-assets/blob/main/feature-extraction-feature-matching/Original-SIFT-algorithm-flow.png" alt="Basic Working of SIFT"/>',ie,w,Se="It stands for scale invariant feature transform. It is a widely used algorithm in computer vision and image processing for detecting and describing local features in images.",ne,x,_e="The working of SIFT is given below:",se,T,Fe="<li><strong>Scale Space Extrema detection:</strong> It starts by detecting potential interest points in an image across multiple scales. It looks for locations in the image where the difference of Gaussian function reaches a maximum or minimum over space and scale. These keypoint locations are considered stable under various scale changes.</li> <li><strong>Keypoint Localization:</strong> Once potential keypoints are identified, SIFT refines their positions to sub-pixel accuracy and discards low-contrast keypoints and keypoints on edges to ensure accurate localization.</li> <li><strong>Orientation Assignment:</strong> SIFT computes a dominant orientation for each keypoint based on local image gradient directions. This step makes the descriptor invariant to image rotation.</li> <li><strong>Descriptor Generation:</strong> A descriptor is computed for each keypoint region, capturing information about the local image gradients near the keypoint. This descriptor is a compact representation that encapsulates the key characteristics of the image patch surrounding the keypoint.</li> <li><strong>Descriptor Matching:</strong> Finally, these descriptors are used for matching keypoints between different images. The descriptors from one image are compared to those in another image to find correspondences.</li>",ae,C,Ie="SIFT’s robustness to various image transformations and its ability to find distinctive features in an image makes it valuable in applications like object recognition, image stitching, and 3D reconstruction.",oe,k,Le="You can learn more about SIFT using the following references:",re,$,He='<li><a href="https://docs.opencv.org/4.x/da/df5/tutorial_py_sift_intro.html" rel="nofollow">Introduction to SIFT (Scale-Invariant Feature Transform)</a></li>',le,S,Me='<a href="https://www.educative.io/answers/what-is-sift" rel="nofollow">What is SIFT</a>',ce,_,Ue='<li><a href="https://www.cse.iitb.ac.in/~ajitvr/CS763/SIFT.pdf" rel="nofollow">SIFT</a></li>',ue,F,pe,I,Re='<img src="https://huggingface.co/datasets/hf-vision/course-assets/blob/main/feature-extraction-feature-matching/Flow-Chart-for-SURF-Feature-Detection.png" alt="Basic Working of SURF"/>',fe,L,De="It stands for Speeded Up Robust features. It is another popular algorithm in computer vision and image processing. It is particularly known for its speed and robustness in detecting and describing local image features.",me,H,Pe="The basic workflow of SURF is given below:",ge,M,je="<li><p><strong>Integral images:</strong> SURF utilizes integral images, precomputed representations of the original image. They allow fast calculations of rectangular area sums within an image, enabling a quicker feature computation.</p></li> <li><p><strong>Blob detection:</strong> Similar to other feature detection algorithms, SURF starts by identifying potential interest points or keypoints in the image. It uses a Hessian matrix to detect blobs or regions that exhibit significant variations in intensity in multiple directions and scales. These regions are potential keypoints.</p></li> <li><p><strong>Scale Selection</strong>: It determines the scale of the keypoints by identifying regions with significant changes in scale-space. It analyzes the determinant of the Hessian matrix across different scales to find robust keypoints at multiple scales.</p></li> <li><p><strong>Orientation Assignment:</strong> For each detected keypoint, SURF assigns a dominant orientation. This is done by calculating Haar wavelet responses in different directions around the keypoint’s neighborhood. Unlike SIFT, SURF uses a set of rectangular filters (Haar wavelets) applied to subregions of the keypoint’s neighborhood. The responses of these filters are used to create a feature vector representing the keypoint.</p></li> <li><p><strong>Descriptor Matching:</strong> The generated descriptors are then used to match key points between different images. Matching involves comparing the feature vectors of keypoints in one image to those in another image to find correspondences.</p></li>",de,U,Ae="The key strengths of SURF lie in its computational efficiency, which is achieved through the use of integral images and Haar wavelet approximations while maintaining robustness to scale, rotation, and illumination changes. This makes SURF suitable for real-time applications where speed plays a crucial part in object detection, tracking, and image stitching.",he,R,qe="You can learn more about SURF using the following references:",ve,D,Ee='<li><p><a href="https://medium.com/@deepanshut041/introduction-to-surf-speeded-up-robust-features-c7396d6e7c4e" rel="nofollow">Medium Blogpost - Introduction to SURF</a></p></li> <li><p>[OpenCV Tutorial - Introduction to SURF (Speeded-Up Robust Features)] (<a href="https://docs.opencv.org/3.4/df/dd2/tutorial_py_surf_intro.html" rel="nofollow">https://docs.opencv.org/3.4/df/dd2/tutorial_py_surf_intro.html</a>)</p></li> <li><p><a href="https://www.ijtra.com/view/feature-extraction-using-surf-algorithm-for-object-recognition.pdf" rel="nofollow">Journal Paper - Feature Extraction Using SURF Algorithm for Object Recognition</a></p></li>',be,W,ye;return u=new N({props:{title:"Feature Description",local:"feature-description",headingTag:"h1"}}),p=new N({props:{title:"How Can We Represent Features In Data Structures?",local:"how-can-we-represent-features-in-data-structures",headingTag:"h2"}}),g=new N({props:{title:"What Makes a Good Descriptor",local:"what-makes-a-good-descriptor",headingTag:"h2"}}),v=new N({props:{title:"Some of the Techniques Used in Feature Descriptors",local:"some-of-the-techniques-used-in-feature-descriptors",headingTag:"h2"}}),b=new N({props:{title:"SIFT",local:"sift",headingTag:"h3"}}),F=new N({props:{title:"SURF",local:"surf",headingTag:"h3"}}),{c(){c=o("meta"),B=s(),O=o("p"),G=s(),P(u.$$.fragment),V=s(),P(p.$$.fragment),Y=s(),f=o("p"),f.textContent=xe,J=s(),m=o("ul"),m.innerHTML=Te,K=s(),P(g.$$.fragment),Q=s(),d=o("p"),d.textContent=Ce,X=s(),h=o("ul"),h.innerHTML=ke,Z=s(),P(v.$$.fragment),ee=s(),P(b.$$.fragment),te=s(),y=o("p"),y.innerHTML=$e,ie=s(),w=o("p"),w.textContent=Se,ne=s(),x=o("p"),x.textContent=_e,se=s(),T=o("ul"),T.innerHTML=Fe,ae=s(),C=o("p"),C.textContent=Ie,oe=s(),k=o("p"),k.textContent=Le,re=s(),$=o("ul"),$.innerHTML=He,le=s(),S=o("p"),S.innerHTML=Me,ce=s(),_=o("ul"),_.innerHTML=Ue,ue=s(),P(F.$$.fragment),pe=s(),I=o("p"),I.innerHTML=Re,fe=s(),L=o("p"),L.textContent=De,me=s(),H=o("p"),H.textContent=Pe,ge=s(),M=o("ul"),M.innerHTML=je,de=s(),U=o("p"),U.textContent=Ae,he=s(),R=o("p"),R.textContent=qe,ve=s(),D=o("ul"),D.innerHTML=Ee,be=s(),W=o("p"),this.h()},l(e){const t=Ye("svelte-u9bgzb",document.head);c=r(t,"META",{name:!0,content:!0}),t.forEach(i),B=a(e),O=r(e,"P",{}),ze(O).forEach(i),G=a(e),j(u.$$.fragment,e),V=a(e),j(p.$$.fragment,e),Y=a(e),f=r(e,"P",{"data-svelte-h":!0}),l(f)!=="svelte-12o2mzc"&&(f.textContent=xe),J=a(e),m=r(e,"UL",{"data-svelte-h":!0}),l(m)!=="svelte-1t4o5a5"&&(m.innerHTML=Te),K=a(e),j(g.$$.fragment,e),Q=a(e),d=r(e,"P",{"data-svelte-h":!0}),l(d)!=="svelte-1c109cp"&&(d.textContent=Ce),X=a(e),h=r(e,"UL",{"data-svelte-h":!0}),l(h)!=="svelte-ovf8rp"&&(h.innerHTML=ke),Z=a(e),j(v.$$.fragment,e),ee=a(e),j(b.$$.fragment,e),te=a(e),y=r(e,"P",{"data-svelte-h":!0}),l(y)!=="svelte-e924vo"&&(y.innerHTML=$e),ie=a(e),w=r(e,"P",{"data-svelte-h":!0}),l(w)!=="svelte-1criuw"&&(w.textContent=Se),ne=a(e),x=r(e,"P",{"data-svelte-h":!0}),l(x)!=="svelte-lcbbmz"&&(x.textContent=_e),se=a(e),T=r(e,"UL",{"data-svelte-h":!0}),l(T)!=="svelte-3mf362"&&(T.innerHTML=Fe),ae=a(e),C=r(e,"P",{"data-svelte-h":!0}),l(C)!=="svelte-jv66t1"&&(C.textContent=Ie),oe=a(e),k=r(e,"P",{"data-svelte-h":!0}),l(k)!=="svelte-1lywwbx"&&(k.textContent=Le),re=a(e),$=r(e,"UL",{"data-svelte-h":!0}),l($)!=="svelte-1mimrff"&&($.innerHTML=He),le=a(e),S=r(e,"P",{"data-svelte-h":!0}),l(S)!=="svelte-1u2rwke"&&(S.innerHTML=Me),ce=a(e),_=r(e,"UL",{"data-svelte-h":!0}),l(_)!=="svelte-1t9s0ql"&&(_.innerHTML=Ue),ue=a(e),j(F.$$.fragment,e),pe=a(e),I=r(e,"P",{"data-svelte-h":!0}),l(I)!=="svelte-1t79xli"&&(I.innerHTML=Re),fe=a(e),L=r(e,"P",{"data-svelte-h":!0}),l(L)!=="svelte-1occd6"&&(L.textContent=De),me=a(e),H=r(e,"P",{"data-svelte-h":!0}),l(H)!=="svelte-1cbx3ud"&&(H.textContent=Pe),ge=a(e),M=r(e,"UL",{"data-svelte-h":!0}),l(M)!=="svelte-f8kdsb"&&(M.innerHTML=je),de=a(e),U=r(e,"P",{"data-svelte-h":!0}),l(U)!=="svelte-1c7o33d"&&(U.textContent=Ae),he=a(e),R=r(e,"P",{"data-svelte-h":!0}),l(R)!=="svelte-18rltfr"&&(R.textContent=qe),ve=a(e),D=r(e,"UL",{"data-svelte-h":!0}),l(D)!=="svelte-lbd5iw"&&(D.innerHTML=Ee),be=a(e),W=r(e,"P",{}),ze(W).forEach(i),this.h()},h(){Ne(c,"name","hf:doc:metadata"),Ne(c,"content",Qe)},m(e,t){Je(document.head,c),n(e,B,t),n(e,O,t),n(e,G,t),A(u,e,t),n(e,V,t),A(p,e,t),n(e,Y,t),n(e,f,t),n(e,J,t),n(e,m,t),n(e,K,t),A(g,e,t),n(e,Q,t),n(e,d,t),n(e,X,t),n(e,h,t),n(e,Z,t),A(v,e,t),n(e,ee,t),A(b,e,t),n(e,te,t),n(e,y,t),n(e,ie,t),n(e,w,t),n(e,ne,t),n(e,x,t),n(e,se,t),n(e,T,t),n(e,ae,t),n(e,C,t),n(e,oe,t),n(e,k,t),n(e,re,t),n(e,$,t),n(e,le,t),n(e,S,t),n(e,ce,t),n(e,_,t),n(e,ue,t),A(F,e,t),n(e,pe,t),n(e,I,t),n(e,fe,t),n(e,L,t),n(e,me,t),n(e,H,t),n(e,ge,t),n(e,M,t),n(e,de,t),n(e,U,t),n(e,he,t),n(e,R,t),n(e,ve,t),n(e,D,t),n(e,be,t),n(e,W,t),ye=!0},p:We,i(e){ye||(q(u.$$.fragment,e),q(p.$$.fragment,e),q(g.$$.fragment,e),q(v.$$.fragment,e),q(b.$$.fragment,e),q(F.$$.fragment,e),ye=!0)},o(e){E(u.$$.fragment,e),E(p.$$.fragment,e),E(g.$$.fragment,e),E(v.$$.fragment,e),E(b.$$.fragment,e),E(F.$$.fragment,e),ye=!1},d(e){e&&(i(B),i(O),i(G),i(V),i(Y),i(f),i(J),i(m),i(K),i(Q),i(d),i(X),i(h),i(Z),i(ee),i(te),i(y),i(ie),i(w),i(ne),i(x),i(se),i(T),i(ae),i(C),i(oe),i(k),i(re),i($),i(le),i(S),i(ce),i(_),i(ue),i(pe),i(I),i(fe),i(L),i(me),i(H),i(ge),i(M),i(de),i(U),i(he),i(R),i(ve),i(D),i(be),i(W)),i(c),z(u,e),z(p,e),z(g,e),z(v,e),z(b,e),z(F,e)}}}const Qe='{"title":"Feature Description","local":"feature-description","sections":[{"title":"How Can We Represent Features In Data Structures?","local":"how-can-we-represent-features-in-data-structures","sections":[],"depth":2},{"title":"What Makes a Good Descriptor","local":"what-makes-a-good-descriptor","sections":[],"depth":2},{"title":"Some of the Techniques Used in Feature Descriptors","local":"some-of-the-techniques-used-in-feature-descriptors","sections":[{"title":"SIFT","local":"sift","sections":[],"depth":3},{"title":"SURF","local":"surf","sections":[],"depth":3}],"depth":2}],"depth":1}';function Xe(we){return Be(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class it extends Ge{constructor(c){super(),Ve(this,c,Xe,Ke,Oe,{})}}export{it as component};
